//Repeater
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <SoftwareSerial.h>


#ifndef APSSID
#define APSSID "WIFI_UPD_R"
#define APPSK  "123456789+"
#endif
SoftwareSerial nextion(12, 13); // RX, TX

IPAddress ip(192, 168, 10, 1);
IPAddress gateway(192, 168, 10, 10);
IPAddress subnet(255, 255, 255, 0);

unsigned int recivePort = 9500;      // local port to listen on

// buffers for receiving and sending data
char packetBuffer[UDP_TX_PACKET_MAX_SIZE + 1]; //buffer to hold incoming packet,
char * values[3];
char * buf[3];
float batt;
unsigned int w_stand_txt;
unsigned int w_stand;

WiFiUDP Udp;

void setup() {
  nextion.begin(9600);
  Serial.begin(115200);
  Serial.println();
  Serial.print("Configuring access point...");
  WiFi.softAPConfig(ip, gateway, subnet);
  WiFi.softAP(APSSID, APPSK);
  delay(500); // Without delay I've seen the IP address blank
  Serial.print("AP IP address: ");
  Serial.println(WiFi.softAPIP());
  Serial.printf("UDP server on port %d\n", recivePort);
  Udp.begin(recivePort);

  nextion.print("p0.pic=");
  nextion.print(0);
  sendTOdisplay();
}

void sendTOdisplay()
{
  nextion.write(0xFF);
  nextion.write(0xFF);
  nextion.write(0xFF);
}

void loop() {
  String cmd;
  cmd += "\"";
  // sind Daten Verfügbar, Lese das packet
  int packetSize = Udp.parsePacket();
  if (packetSize) {

    // Lese das packet in das packetBufffer
    int n = Udp.read(packetBuffer, UDP_TX_PACKET_MAX_SIZE);
    packetBuffer[n] = 0;
    // Serial.println("Contents:");
    // Serial.println(packetBuffer);
    //Empfangene Daten zerlegen
    char* ptr = strtok(packetBuffer, ";");
    for (byte i = 0; i < sizeof(values) / sizeof(values[0]); i++)
    {
      values[i] = ptr;
      ptr = strtok(NULL, ";");
    }
    //for (byte i = 0; i < sizeof(values) / sizeof(values[0]); i++)
    //  Serial.println(values[i]);

    buf[0] = strtok(values[0], ":");
    batt = atof(strtok(NULL, ":"));     //Batterie Wert
    buf[1] = strtok(values[1], ":");
    buf[2] = strtok(NULL, ":");     // Counter
    buf[3] = strtok(values[2], ":");
    w_stand_txt = atof(strtok(NULL, ":"));     // Messwert Ultraschallsensor

    //Daten an das Display senden
    nextion.print("batterie.txt=" + cmd + batt);
    nextion.print(" V" + cmd);
    sendTOdisplay();
    nextion.print("zeit.txt=" + cmd + buf[2] + cmd);
    sendTOdisplay();
    nextion.print("w_stand.txt=" + cmd + w_stand_txt + cmd);
    sendTOdisplay();
    w_stand = w_stand_txt * 0.1666667; // Berechnung für die Seule
    w_stand = 100 - w_stand;           // Berechnung für die Seule
    nextion.print("wstand.val=");
    nextion.print(w_stand);
    sendTOdisplay();
    if (batt >= 3.8 && batt <= 4.1)
    {
      nextion.print("p0.pic=");
      nextion.print(4);
      sendTOdisplay();
    }
    if (batt >= 3.5 && batt <= 3.8)
    {
      nextion.print("p0.pic=");
      nextion.print(3);
      sendTOdisplay();
    }
    if (batt >= 3.3 && batt <= 3.5)
    {
      nextion.print("p0.pic=");
      nextion.print(2);
      sendTOdisplay();
    }
    if (batt >= 0 && batt <= 3.3)
    {
      nextion.print("p0.pic=");
      nextion.print(1);
      sendTOdisplay();
    }
    delay(100);
  }

}
