#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <EEPROM.h>

#ifndef STASSID
#define STASSID "WIFI_UPD_R"
#define STAPSK  "123456789+"
#endif

IPAddress ip(192, 168, 10, 10);
IPAddress gateway(192, 168, 10, 1);
IPAddress subnet(255, 255, 255, 0);
// Recipient UDP Port
unsigned int sendPort = 9500;

int trigger = 2;
int echo = 4;
long dauer = 0;
int counter = 0;

unsigned int raw = 0;
float batt = 0.0;
long wasser = 0;
const int sleepSeconds = 2000;

WiFiUDP Udp;

void setup() {
  pinMode(A0, INPUT);
  Serial.begin(115200);
  pinMode(trigger, OUTPUT);
  pinMode(echo, INPUT);

  WiFi.mode(WIFI_STA);
  WiFi.config(ip, gateway, subnet);
  WiFi.begin(STASSID, STAPSK);
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print('.');
    delay(500);
  }
  Serial.print("Connected! IP address: ");
  Serial.println(WiFi.localIP());
  Serial.printf("UDP server on port %d\n", sendPort);
  Udp.begin(sendPort);
}

void batt_status()
{
  raw = analogRead(A0);
  batt = raw / 1023.0;
  batt = batt * 4.2;
}

void zeit()
{
  counter++;
  EEPROM.write(1, counter);
  Serial.println(counter);
  if (counter >= 21)
  {
    counter = 0;
    EEPROM.write(1, counter);
    EEPROM.commit();
    EEPROM.end();
    ESP.reset();
  }
}

void loop() {
  EEPROM.begin(512);
  counter = EEPROM.read(1);
  batt_status();
  zeit();
  digitalWrite(trigger, LOW);
  delay(5);
  digitalWrite(trigger, HIGH);
  delay(10);
  digitalWrite(trigger, LOW);
  dauer = pulseIn(echo, HIGH);
  wasser = (dauer / 2) / 29.1;

for (int i=0; i <= 3; i++){
  Udp.beginPacket(gateway, sendPort);
  Udp.write("Batterie:");
  Udp.print(batt);
  Udp.write(";count:");
  Udp.print(counter);
  Udp.write(";wasser:");
  Udp.print(wasser);
  Udp.endPacket();
  delay(1000);
}
  EEPROM.commit();
  EEPROM.end();

  delay(3000);
  ESP.deepSleep(sleepSeconds * 1000000);

}
